#ifndef FUSION_GENERAL_WRAPPER_HEADER_H
#define FUSION_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "Fusion_SubDataWrapper.h"
#include "fusion/executable.h"
#include "Fusion_PubDataWrapper.h"

using namespace jac::ap::cameradrivingperservice::proxy;
using namespace jac::ap::cameraparkingservice::proxy;
using namespace jac::ap::lidarperceptionservice::proxy;
using namespace jac::ap::vedservice::proxy;
using namespace jac::ap::fusionservice::skeleton;

//pubwrappers
GENERATE_PUB_WRAPPER(Object_Provide, FUSION_LidarObjects_PubDataWrapper, FusionServiceSkeleton, dpc::TrafficParticipantStruct, ObjectEvent);

//subwrappers
GENERATE_SUB_WRAPPER(FrontCamDrvPerception2Fusion_Required, FrontCamDrvPerception2Fusion_SubDataWrapper, CameraDrivingPerceptionServiceProxy, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent, "19", 10);
GENERATE_SUB_WRAPPER(LeftCamDrvPerception2Fusion_Required, LeftCamDrvPerception2Fusion_SubDataWrapper, CameraDrivingPerceptionServiceProxy, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent, "19", 10);
GENERATE_SUB_WRAPPER(RightCamDrvPerception2Fusion_Required, RightCamDrvPerception2Fusion_SubDataWrapper, CameraDrivingPerceptionServiceProxy, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent, "19", 10);
GENERATE_SUB_WRAPPER(RearCamDrvPerception2Fusion_Required, RearCamDrvPerception2Fusion_SubDataWrapper, CameraDrivingPerceptionServiceProxy, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent, "19", 10);
GENERATE_SUB_WRAPPER(CamPrkPerception2Fusion_Required, CamPrkPerception2Fusion_SubDataWrapper, CameraParkingServiceProxy, perception::vector_CameraPerception2Fusion, CameraPrkPerception2FusionEvent, "17", 10);
GENERATE_SUB_WRAPPER(VED2FusionEgoMotion_Required, VED2FusionEgoMotion_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);
GENERATE_SUB_WRAPPER(LidarPerception2Fusion_Required, LidarPerception2Fusion_SubDataWrapper, LiDARPerceptionServiceProxy, perception::vector_LiDARPerception2Fusion, LiDARPerception2FusionEvent, "12", 10);

class GeneralWrapper {
public:
    //Providers
    Object_Provide _Object_Provide;

    //Reqireds
    FrontCamDrvPerception2Fusion_Required _FrontCamDrvPerception2Fusion_Required;
    LeftCamDrvPerception2Fusion_Required _LeftCamDrvPerception2Fusion_Required;
    RightCamDrvPerception2Fusion_Required _RightCamDrvPerception2Fusion_Required;
    RearCamDrvPerception2Fusion_Required _RearCamDrvPerception2Fusion_Required;
    CamPrkPerception2Fusion_Required _CamPrkPerception2Fusion_Required;
    VED2FusionEgoMotion_Required _VED2FusionEgoMotion_Required;
    LidarPerception2Fusion_Required _LidarPerception2Fusion_Required;

    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif
